
local ViewBase4U = require("ViewBase4U")

local AlertBase4U = class("AlertBase4U", ViewBase4U)

function AlertBase4U:ctor(options)
    AlertBase4U.super.ctor(self)

    self._exiting = false
    self:hide()

    self._bgNode = display.newNode():addTo(self)
    self._bgNode:setCascadeOpacityEnabled(true)
    self._bgNode:opacity(0)
    self._alertNode = display.newNode():addTo(self)
    self._alertNode:setCascadeOpacityEnabled(true)
    self._alertNode:opacity(0)
    self._alertNode:scale(0.5)
end

function AlertBase4U:actionEnter()
    self._exiting = false

    self:show()

    self._bgNode:stopAllActions()
    self._bgNode:runAction(
        cca.fadeTo(0.3, 1))

    self._alertNode:stopAllActions()
    self._alertNode:runAction(cca.spawn({
        cca.fadeTo(0.2, 1),
        cca.bounceOut(cca.scaleTo(0.3, 1)),
        }))
end

function AlertBase4U:actionExit(needRemove)
    local needRemove = needRemove
    if needRemove == nil then needRemove = true end

    if self._exiting then return end
    self._exiting = true
    
    if needRemove then
        self:removeSelf()
    else
        self:hide()
    end
end

function AlertBase4U:getBGNode()
    return self._bgNode
end

function AlertBase4U:getAlertNode()
    return self._alertNode
end

function AlertBase4U:setBGVisible(visible)
    self._bgNode:setVisible(visible)
end

return AlertBase4U