------------------------------------------------------------------------------
--Load origin framework
------------------------------------------------------------------------------
-- cc.LuaLoadChunksFromZIP("res/framework_precompiled.zip")

------------------------------------------------------------------------------
--If you would update the modoules which have been require here,
--you can reset them, and require them again in modoule "AppMain"
------------------------------------------------------------------------------

function __G__TRACKBACK__(errorMessage)
    printInfo("----------------------------------------")
    printInfo("LUA ERROR: " .. tostring(errorMessage) .. "\n")
    printInfo(debug.traceback("", 2))
    printInfo("----------------------------------------")
end

package.path = package.path .. ";src/"
package.path = package.path .. ";src/?.lua"
package.path = package.path .. ';src/app/protobuf/?.lua'
package.path = package.path .. ';src/app/protocol/?.lua'

-- cc.FileUtils:getInstance():setPopupNotify(false)
-- cc.FileUtils:getInstance():addSearchPath("src_quick/", true)
-- cc.FileUtils:getInstance():addSearchPath("src/", true)
-- cc.FileUtils:getInstance():addSearchPath("lib/", true)
-- cc.FileUtils:getInstance():addSearchPath("", true)

-- print("----------------preload-------------------")
-- for k, v in pairs(package.preload) do
--     print(k)
-- end
-- print("------------------------------------------")
-- print("--------------package.preload-------------")
-- for k, v in pairs(package.preload) do
--     print(k)
-- end
-- print("------------------------------------------")
-- print("-----------------loaded-------------------")
-- for k, v in pairs(package.loaded) do
--     print(k)
-- end
-- print("------------------------------------------")

require("config")
require("cocos.init")
require("framework.init")
local AlertOK4U = require("AlertOK4U")

dump(cc.FileUtils:getInstance():getSearchPaths())

-- cc.FileUtils:getInstance():addSearchPath("res/", true)
-- cc.FileUtils:getInstance():addSearchPath(device.writablePath .. "update/", true)

-- print("------------------------------------------")
-- for k, v in pairs(package.loaded) do
--     print(k)
-- end
-- print("------------------------------------------")
-- print("-------------------_G---------------------")
-- for k, v in pairs(_G) do
--     print(k)
-- end
-- print("------------------------------------------")

-- dump(cc.FileUtils:getInstance():getSearchPaths())


------------------------------------------------------------------------------
--define UpdateScene
------------------------------------------------------------------------------
local UpdateScene = class("UpdateScene", function()
    return display.newScene("UpdateScene")
end)

z.ResourceManager:getInstance():init()
if z.GlobalDefines:getLanguage() == 0 then
    z.ResourceManager:getInstance():setLocale(1)
elseif z.GlobalDefines:getLanguage() == 1 then
    z.ResourceManager:getInstance():setLocale(0)
else
    z.ResourceManager:getInstance():setLocale(1)
end

printInfo("GAME_PLATFORM: %d", z.GlobalDefines:getGamePlatform())
if z.GlobalDefines:getGamePlatform() == 3 then -- TCI
    UpdateScene.NEED_UPDATE = false
else
    UpdateScene.NEED_UPDATE = true
end
if z.GlobalDefines:getGamePlatform() == 4 then -- EN
    UpdateScene.SERVER_URL = "http://cdn.casino.file.zenistgame.com/casino_versions_en"
else
    UpdateScene.SERVER_URL = "http://cdn.casino.file.zenistgame.com/casino_versions"
    -- UpdateScene.SERVER_URL = "http://cdn.casino.file.zenistgame.com/casino_versions_dev"
end
UpdateScene.PARAM = ""

UpdateScene.VERSION_NUM_FILENAME = "version"
UpdateScene.VERSION_INFO_FILENAME = "version.info"
UpdateScene.T_VERSION_NUM = "version"
UpdateScene.T_VERSION_INFO = "version.info"
UpdateScene.T_FILES = "files"
UpdateScene.UPDATE_TEMP_POSTFIX = ".update"
UpdateScene.VERSION_UPDATED_POSTFIX = ".updated"
UpdateScene.UPDATE_PATH = "update/"

UpdateScene.DOWNLOAD_LIST = {}
UpdateScene.DOWNLOAD_LIST_SAVE = {}
UpdateScene.DOWNLOADED_LIST = {}
UpdateScene.DOWNLOAD_TOTAL_SIZE = 0
UpdateScene.DOWNLOADED_TOTAL_SIZE = 0
UpdateScene.DOWNLOAD_PROGRESS_SIZE = 0
UpdateScene.DOWNLOAD_FINISHED = false
UpdateScene.RENAME_LIST = {}
UpdateScene.RENAME_TOTAL_SIZE = 0
UpdateScene.RENAMED_TOTAL_SIZE = 0

UpdateScene.CLIENT_VERSION_INFO = {}
UpdateScene.CLIENT_VERSION = nil
UpdateScene.CLIENT_VERSION_STR = nil

UpdateScene.CLIENT_VERSION_INFO = {}
UpdateScene.CLIENT_VERSION = nil
UpdateScene.CLIENT_VERSION_STR = nil

UpdateScene.SERVER_VERSION_INFO = {}
UpdateScene.SERVER_VERSION = nil
UpdateScene.SERVER_VERSION_STR = nil

local function printLog(tag, fmt, ...)
    local t = {
        "[",
        string.upper(tostring(tag)),
        "] ",
        string.format(tostring(fmt), ...)
    }
    print(table.concat(t))
end

local function printInfo(fmt, ...)
    printLog("INFO", fmt, ...)
end

local function isFileExists(path)
    local data = cc.FileUtils:getInstance():getStringFromFile(path)
    if data == "" then
        return false
    else
        return true
    end
    -- return cc.FileUtils:getInstance():isFileExists(path)
    -- local file = io.open(path, "rb")
    -- if file then
    --     io.close(file)
    --     return true
    -- else
    --     return false
    -- end
end

local function compareVersion(a, b)
    -- assert(#a == #b)
    local lengthA = #a
    local lengthB = #b
    assert(lengthA >= 3 and lengthA <= 4)
    assert(lengthB >= 3 and lengthB <= 4)
    for i = 1, 3 do
        if tonumber(a[i]) < tonumber(b[i]) then
            return -1
        elseif tonumber(a[i]) > tonumber(b[i]) then
            return 1
        end
    end
    if lengthA == 3 and lengthB == 3 then
        return 0
    elseif lengthA == 3 and lengthB == 4 then
        return -1
    elseif lengthA == 4 and lengthB == 3 then
        return 1
    else
        if tonumber(a[4]) < tonumber(b[4]) then
            return -1
        elseif tonumber(a[4]) > tonumber(b[4]) then
            return 1
        else
            return 0
        end
    end
end

local function hex(s)
    s = string.gsub(s,"(.)",function (x) return string.format("%02X",string.byte(x)) end)
    return s
end

local function makeDir(path)
    printInfo("------------makeDir: %s", path)
    local tempPath = path
    local head = ""
    repeat
        -- printInfo("------------tempPath: %s, head: %s", tempPath, head)
        local firstDelimiter = string.find(tempPath, "/")

        if not firstDelimiter then
            if not isFileExists(head .. tempPath) then
                lfs.mkdir(head .. tempPath)
            end
            return
        else
            local tempDir = string.sub(tempPath, 1, firstDelimiter - 1)
            head = head .. tempDir .. "/"
            if not isFileExists(head) then
                lfs.mkdir(head)
            end
            tempPath = string.sub(tempPath, firstDelimiter + 1, #tempPath)
        end
    until not tempPath
end

local function readFile(path)
    return cc.HelperFunc:getFileDataFileUtils(path)
    -- local file = io.open(path, "rb")
    -- if file then
    --     local content = file:read("*all")
    --     io.close(file)
    --     return content
    -- end
    -- return nil
end

local function removeFile(path)
    printInfo("------------removeFile: %s", path)
    z.FileOperation:removeFileOrPath(path)
    -- os.remove(path)
    -- io.writefile(path, "")
    -- if device.platform == "windows" then
    --     --os.execute("del " .. string.gsub(path, '/', '\\'))
    -- else
    --     os.execute("rm " .. path)
    -- end
end

local function removeDir(path, removeDirSelf)
    printInfo("------------removeDir: %s", path)
    if removeDirSelf then
        z.FileOperation:removeFileOrPath(path)
    else
        z.FileOperation:removeAllFilesInPath(path)
    end
    -- if string.sub(path, -1) == "/" then
    --     path = string.sub(path, 1, -2)
    -- end
    -- printInfo("------------removeDir: %s", path)
    -- -- if isFileExists(path) then
    --     local function _rmdir(path)
    --         local iter, dir_obj = lfs.dir(path)
    --         while true do
    --             local dir = iter(dir_obj)
    --             if dir == nil then break end
    --             if dir ~= "." and dir ~= ".." then
    --                 local curDir = path..dir
    --                 local mode = lfs.attributes(curDir, "mode") 
    --                 if mode == "directory" then
    --                     _rmdir(curDir.."/")
    --                 elseif mode == "file" then
    --                     os.remove(curDir)
    --                 end
    --             end
    --         end
    --         local succ, des = os.remove(path)
    --         -- if des then printInfo(des) end
    --         return succ
    --     end
    --     _rmdir(path)
    -- -- end
    return true
end

local function checkFile(fileName, cryptoCode)
    printInfo("------------checkFile: %s", fileName)
    -- printInfo("------------cryptoCode: %s", cryptoCode)

    if not isFileExists(fileName) then
        printInfo("------------checkFile failed file not exists: %s", fileName)
        return false
    end

    local data = readFile(fileName)
    if data == nil then
        return false
    end

    if cryptoCode == nil then
        return true
    end

    local ms = crypto.md5(hex(data))
    -- local ms = cc.Crypto:MD5File(fileName)
    -- local ms = z.FileOperation:MD5FileOriginal(fileName)
    printInfo("------------file cryptoCode: %s, need: %s", ms, cryptoCode)
    if ms == cryptoCode then
        return true
    end

    return false
end

local function checkDirOK(path)
    require "lfs"
    local oldpath = lfs.currentdir()
    -- printInfo("------------old path------> "..oldpath)

    if lfs.chdir(path) then
        lfs.chdir(oldpath)
        -- printInfo("------------path check OK------> "..path)
        return true
    end

    if lfs.mkdir(path) then
        -- printInfo("------------path create OK------> "..path)
        return true
    end
end

local function checkClientVersions()
    local versionInfo 
    local updatedVersion
    local originalVersion

    printInfo("-----checking----- check client versions")

    -- updated version
    versionInfo = cc.FileUtils:getInstance():fullPathForFilename(UpdateScene.VERSION_INFO_FILENAME .. UpdateScene.VERSION_UPDATED_POSTFIX)
    -- versionInfo = device.writablePath .. UpdateScene.UPDATE_PATH .. UpdateScene.VERSION_INFO_FILENAME
    if not isFileExists(versionInfo) then
        printInfo("-----checking----- 无更新版本信息，清空所有更新包")
        removeDir(device.writablePath .. UpdateScene.UPDATE_PATH, false)
        return
    end

    -- get updated version
    local data = cc.FileUtils:getInstance():getStringFromFile(versionInfo)
    local content = string.split(data, "\n")
    printInfo("-----checking----- updated client version: %s", content[1])
    updatedVersion = string.split(content[1], ".")

    -- original version
    versionInfo = cc.FileUtils:getInstance():fullPathForFilename(UpdateScene.VERSION_INFO_FILENAME)
    assert(isFileExists(versionInfo))

    -- get original version
    local data = cc.FileUtils:getInstance():getStringFromFile(versionInfo)
    local content = string.split(data, "\n")
    printInfo("-----checking----- original client version: %s", content[1])
    originalVersion = string.split(content[1], ".")

    -- 若本地版本比更新包版本更高，则删除更新包版本(适用于从应用商店手动更新大版本的情况)
    if compareVersion(originalVersion, updatedVersion) > 0 then
        printInfo("-----checking----- 原始版本比更新包更新，清空所有更新包")
        removeDir(device.writablePath .. UpdateScene.UPDATE_PATH, false)
    end
end

local function getClientVersionInfo()
    local versionInfo 
    versionInfo = cc.FileUtils:getInstance():fullPathForFilename(UpdateScene.VERSION_INFO_FILENAME .. UpdateScene.VERSION_UPDATED_POSTFIX)
    if not isFileExists(versionInfo) then
        versionInfo = cc.FileUtils:getInstance():fullPathForFilename(UpdateScene.VERSION_INFO_FILENAME)
    end
    printInfo("client version info: %s", versionInfo)
    -- local f = io.open(versionInfo, "r")
    local data = cc.FileUtils:getInstance():getStringFromFile(versionInfo)
    local content = string.split(data, "\n")
    for index, i in ipairs(content) do
        if index == 1 then
            printInfo("client version: %s", i)
            UpdateScene.CLIENT_VERSION_STR = i
            UpdateScene.CLIENT_VERSION = string.split(i, ".")
        else
            local info = string.split(i, " ")
            assert(#info == 3)
            UpdateScene.CLIENT_VERSION_INFO[info[3]] = {
                md5 = info[1],
                size = info[2]
            }
        end
    end
end

local function getServerVersionInfo(data)
    local versionInfo = device.writablePath .. UpdateScene.UPDATE_PATH .. UpdateScene.VERSION_INFO_FILENAME .. UpdateScene.UPDATE_TEMP_POSTFIX
    printInfo("server version info: %s", versionInfo)
    local data = cc.FileUtils:getInstance():getStringFromFile(versionInfo)
    local content = string.split(data, "\n")
    for index, i in ipairs(content) do
        if index == 1 then
            printInfo("server version: %s", i)
            assert(i == UpdateScene.SERVER_VERSION_STR)
        else
            local info = string.split(i, " ")
            assert(#info == 3)
            UpdateScene.SERVER_VERSION_INFO[info[3]] = {
                md5 = info[1],
                size = info[2]
            }
        end
    end
end

local function getDownloadList()
    UpdateScene.DOWNLOAD_LIST = {}
    UpdateScene.DOWNLOAD_LIST_SAVE = {}
    UpdateScene.DOWNLOADED_LIST = {}
    UpdateScene.DOWNLOAD_TOTAL_SIZE = 0
    UpdateScene.DOWNLOAD_PROGRESS_SIZE = 0
    UpdateScene.DOWNLOADED_TOTAL_SIZE = 0

    for ks, vs in pairs(UpdateScene.SERVER_VERSION_INFO) do
        if not UpdateScene.CLIENT_VERSION_INFO[ks] then
            UpdateScene.DOWNLOAD_LIST[ks] = vs
            UpdateScene.DOWNLOAD_TOTAL_SIZE = UpdateScene.DOWNLOAD_TOTAL_SIZE + vs.size
        elseif UpdateScene.CLIENT_VERSION_INFO[ks].md5 ~= vs.md5 then
            UpdateScene.DOWNLOAD_LIST[ks] = vs
            UpdateScene.DOWNLOAD_TOTAL_SIZE = UpdateScene.DOWNLOAD_TOTAL_SIZE + vs.size
        end
    end

    UpdateScene.DOWNLOAD_LIST_SAVE = clone(UpdateScene.DOWNLOAD_LIST)

    printInfo(">>>>>>>>>>>>>>>>>>>>> need download size: %d", UpdateScene.DOWNLOAD_TOTAL_SIZE)
end

function UpdateScene:ctor()
    self.updatePath = device.writablePath .. UpdateScene.UPDATE_PATH

    self._currentProgress = 0
    self._loading = true

    cc.ui.UIImage.new("image/loading_bg.png")
        :align(display.CENTER, display.cx, display.cy)
        :addTo(self)

    display.newSprite("image/casino_logo.png")
        :align(display.CENTER, display.cx, display.cy + 26)
        :addTo(self)

    display.newSprite("image/loading_new_bar_bg1.png")
        :align(display.CENTER, display.cx, 80)
        :addTo(self)

    self._progress = display.newProgressTimer("image/loading_new_bar_bg2.png", 
            display.PROGRESS_TIMER_BAR)
        :align(display.CENTER, display.cx, 80)
        :addTo(self)
    self._progress:setMidpoint(cc.p(0, 0))
    self._progress:setBarChangeRate(cc.p(1, 0))
    self._progress:setPercentage(0)

    self._progressNode = display.newNode()
        -- :hide()
        :align(display.CENTER, display.cx, 50)
        :addTo(self)

    self._progressLabel = cc.ui.UILabel.new({
        text = "",
        size = 20,
        color = cc.c3b(240, 200, 125),
        align = cc.ui.TEXT_ALIGN_CENTER
    })
        :align(display.CENTER, 0, 0)
        :addTo(self._progressNode)

    -- cc.ui.UILabel.new({
    --     text = "更新中",
    --     size = 20,
    --     align = cc.ui.TEXT_ALIGN_RIGHT
    -- })
    --     :align(display.RIGHT_CENTER, -120, 0)
    --     :addTo(self._progressNode)

    -- cc.ui.UILabel.new({
    --     text = "/",
    --     size = 20,
    --     align = cc.ui.TEXT_ALIGN_CENTER
    -- })
    --     :align(display.CENTER, 0, 0)
    --     :addTo(self._progressNode)

    -- self._totalSizeLabel = cc.ui.UILabel.new({
    --     text = "",
    --     size = 20,
    --     align = cc.ui.TEXT_ALIGN_LEFT,
    -- })
    --     :align(display.LEFT_CENTER, 10, 0)
    --     :addTo(self._progressNode)

    -- self._downloadedSizeLabel = cc.ui.UILabel.new({
    --     text = "",
    --     size = 20,
    --     align = cc.ui.TEXT_ALIGN_RIGHT,
    -- })
    --     :align(display.RIGHT_CENTER, - 10, 0)
    --     :addTo(self._progressNode)
end

function UpdateScene:finalUpdateFiles()
    printInfo("------------finalUpdateFiles")

    printInfo("------------finalUpdateFiles check files")

    local checkOK = true
    for k, v in pairs(UpdateScene.DOWNLOAD_LIST_SAVE) do
        if not checkFile(self.updatePath .. k .. UpdateScene.UPDATE_TEMP_POSTFIX, v.md5) then
            printInfo("------------finalUpdateFiles check files error: %s", k)
            checkOK = false
            break
        end
    end

    -- 下载失败
    if not checkOK then
        local alertView = AlertOK4U.new({
            desc = z.ResourceManager:getInstance():getLocalizedString("check_update_pack_failed"),
            ok = z.ResourceManager:getInstance():getLocalizedString("exit"),
            okCallback = function() cc.Director:getInstance():endToLua() end,
            })
            :pos(display.cx, display.cy)
            :addTo(self)
        alertView:actionEnter()
        self:finishUpdate(false)
        return
    end

    -- 开始重新命名列表规划
    UpdateScene.RENAME_LIST = {}
    UpdateScene.RENAME_TOTAL_SIZE = 0
    UpdateScene.RENAMED_TOTAL_SIZE = 0
    UpdateScene.DOWNLOAD_FINISHED = true

    -- 刷新版本信息
    local filename = self.updatePath .. UpdateScene.VERSION_INFO_FILENAME .. UpdateScene.UPDATE_TEMP_POSTFIX
    local newFilename = string.sub(filename, 1, - string.len(UpdateScene.UPDATE_TEMP_POSTFIX) - 1) .. UpdateScene.VERSION_UPDATED_POSTFIX
    -- os.rename(filename, newFilename)
    table.insert(UpdateScene.RENAME_LIST, {old = filename, new = newFilename})
    UpdateScene.RENAME_TOTAL_SIZE = UpdateScene.RENAME_TOTAL_SIZE + 1

    for i, filename in ipairs(UpdateScene.DOWNLOADED_LIST) do
        -- printInfo(i,v)
        -- local data = readFile(filename)
        -- local newFilename = string.sub(filename, 1, - string.len(UpdateScene.UPDATE_TEMP_POSTFIX) - 1)
        -- removeFile(newFilename)
        -- io.writefile(newFilename, data)
        -- removeFile(filename)
        local newFilename = string.sub(filename, 1, - string.len(UpdateScene.UPDATE_TEMP_POSTFIX) - 1)
        -- os.rename(filename, newFilename)
        table.insert(UpdateScene.RENAME_LIST, {old = filename, new = newFilename})
        UpdateScene.RENAME_TOTAL_SIZE = UpdateScene.RENAME_TOTAL_SIZE + 1
    end
    -- self:finishUpdate()
end

function UpdateScene:requestNextFile()

    printInfo("------------requestNextFile")
    for k, v in pairs(UpdateScene.DOWNLOAD_LIST) do
        self.currentDownloadFile = k
        self.currentDownloadFileInfo = v
        UpdateScene.DOWNLOAD_LIST[k] = nil

        printInfo("------------requestNextFile : %s", k)

        self:requestFromServer(UpdateScene.SERVER_VERSION_STR .. "/" .. k)
        return
    end

    self:finalUpdateFiles()

    -- self.numFileCheck = self.numFileCheck + 1
    -- self.curStageFile = self.fileListNew.stage[self.numFileCheck]
    -- if self.curStageFile and self.curStageFile.name then
    --     local fn = self.updatePath .. self.curStageFile.name
    --     if checkFile(fn, self.curStageFile.code) then
    --         self:requestNextFile()
    --         return
    --     end
    --     fn = fn .. UpdateScene.UPDATE_TEMP_POSTFIX
    --     -- printInfo("------------fn: %s", fn)
    --     if checkFile(fn, self.curStageFile.code) then
    --         table.insert(UpdateScene.DOWNLOADED_LIST, fn)
    --         self:requestNextFile()
    --         return
    --     end
    --     self:requestFromServer(self.fileListNew.ver .. "/" .. self.curStageFile.name)
    --     return
    -- end
end

function UpdateScene:update(dt)

    if self._loading then
        local downloadRate = 0
        if UpdateScene.DOWNLOAD_TOTAL_SIZE > 0 then
            downloadRate = 50 * (math.min(UpdateScene.DOWNLOADED_TOTAL_SIZE + UpdateScene.DOWNLOAD_PROGRESS_SIZE, UpdateScene.DOWNLOAD_TOTAL_SIZE) 
                / UpdateScene.DOWNLOAD_TOTAL_SIZE)
        end
        local renameRate = 0
        if UpdateScene.RENAME_TOTAL_SIZE > 0 then
            renameRate = 20 * (UpdateScene.RENAMED_TOTAL_SIZE / UpdateScene.RENAME_TOTAL_SIZE)
        end
        local rate = 30 + downloadRate + renameRate

        if rate >= 100 then
            self._currentProgress = 100
            self:endProcess()

        elseif self._currentProgress < rate then
            self._currentProgress = rate
            self._progress:stopAllActions()
            self._progress:runAction(cca.sineInOut(cca.progressTo(0.2, rate)))
        end 
    end

    if UpdateScene.DOWNLOAD_TOTAL_SIZE > 0 then
        if UpdateScene.DOWNLOADED_TOTAL_SIZE < UpdateScene.DOWNLOAD_TOTAL_SIZE then
            local total = UpdateScene.DOWNLOAD_TOTAL_SIZE / 1000
            local downloaded = math.min(UpdateScene.DOWNLOADED_TOTAL_SIZE + UpdateScene.DOWNLOAD_PROGRESS_SIZE, UpdateScene.DOWNLOAD_TOTAL_SIZE) / 1000
            self._progressLabel:setString(string.format(z.ResourceManager:getInstance():getLocalizedString("downloading_update"), downloaded, total))
        else
            self._progressLabel:setString(z.ResourceManager:getInstance():getLocalizedString("downloading_finished_game_loading"))
        end
    end

	if self.dataRecv then
        printInfo("------------dataRecv")

        -- 获取服务端版本号信息
		if self.requestingType == UpdateScene.T_VERSION_NUM then
            printInfo("------------dataRecv version")
            -- printInfo("server version: %s", self.dataRecv)
            UpdateScene.SERVER_VERSION_STR = self.dataRecv
            UpdateScene.SERVER_VERSION = string.split(self.dataRecv, ".")
			self.dataRecv = nil

			-- self.fileListNew = dofile(self.newListFile)
			-- if self.fileListNew == nil then
			-- 	-- printInfo(self.newListFile ..": Open Error!")
			-- 	self:finishUpdate()
			-- 	return
			-- end

            printInfo("------------client version: %s", UpdateScene.CLIENT_VERSION_STR)
			printInfo("------------server version: %s", UpdateScene.SERVER_VERSION_STR)

            local compareResult = compareVersion(UpdateScene.CLIENT_VERSION, UpdateScene.SERVER_VERSION)
			if compareResult >= 0 then
                printInfo("------------版本号不低于服务器，结束更新！")
                self._progressLabel:setString(z.ResourceManager:getInstance():getLocalizedString("current_version_newest"))
				self:finishUpdate(true)
				return
            else
                -- 大版本不支持更新
                if UpdateScene.CLIENT_VERSION[1] ~= UpdateScene.SERVER_VERSION[1] or
                    UpdateScene.CLIENT_VERSION[2] ~= UpdateScene.SERVER_VERSION[2] then
                    local alertView = AlertOK4U.new({
                        desc = z.ResourceManager:getInstance():getLocalizedString("cannot_update_for_base"),
                        ok = z.ResourceManager:getInstance():getLocalizedString("exit"),
                        okCallback = function() cc.Director:getInstance():endToLua() end,
                        })
                        :pos(display.cx, display.cy)
                        :addTo(self)
                    alertView:actionEnter()
                    self:finishUpdate(false)
                    return
                end
                self._progressLabel:setString(
                    string.format(z.ResourceManager:getInstance():getLocalizedString("newest_version_is"),
                        UpdateScene.SERVER_VERSION_STR))
			end

            self.requesting = UpdateScene.SERVER_VERSION_STR .. "/" .. UpdateScene.VERSION_INFO_FILENAME
            self.requestingType = UpdateScene.T_VERSION_INFO
            self:requestFromServer(self.requesting)
            return
		end

        -- 获取服务端版本详细信息
        if self.requestingType == UpdateScene.T_VERSION_INFO then
            printInfo("------------dataRecv version.info")

            local filename = self.updatePath .. UpdateScene.VERSION_INFO_FILENAME .. UpdateScene.UPDATE_TEMP_POSTFIX
            io.writefile(filename, self.dataRecv)
            self.dataRecv = nil

            getServerVersionInfo()
            getDownloadList()

            self.requesting = ""
            self.requestingType = UpdateScene.T_FILES
            self:requestNextFile()
            return
        end

        if self.requestingType == UpdateScene.T_FILES then
            printInfo("------------dataRecv files: %s", self.currentDownloadFile)
            local filename = self.updatePath .. self.currentDownloadFile .. UpdateScene.UPDATE_TEMP_POSTFIX
            -- printInfo("------------dataRecv filename: %s", filename)
            local dir = string.match(filename, "(.+)/[^/]*%.%w+$") 
            -- printInfo("------------dataRecv dir: %s", dir)
            makeDir(dir)
            io.writefile(filename, self.dataRecv)
            self.dataRecv = nil

            if checkFile(filename, self.currentDownloadFileInfo.md5) then
                table.insert(UpdateScene.DOWNLOADED_LIST, filename)
                UpdateScene.DOWNLOADED_TOTAL_SIZE = UpdateScene.DOWNLOADED_TOTAL_SIZE + self.currentDownloadFileInfo.size
                UpdateScene.DOWNLOAD_PROGRESS_SIZE = 0
                self:requestNextFile()
            else
                printInfo("------------downloaded but md5 check failed! %s", self.currentDownloadFile)
                -- 无法连接服务器，请检查网络
                local alertView = AlertOK4U.new({
                    desc = z.ResourceManager:getInstance():getLocalizedString("check_update_pack_failed"),
                    ok = z.ResourceManager:getInstance():getLocalizedString("exit"),
                    okCallback = function() cc.Director:getInstance():endToLua() end,
                    })
                    :pos(display.cx, display.cy)
                    :addTo(self)
                alertView:actionEnter()
                self:finishUpdate(false)
            end
            return
        end

        return
	end

    if UpdateScene.DOWNLOAD_FINISHED then
        for i = 1, 10 do
            if #UpdateScene.RENAME_LIST > 0 then
                printInfo("------------remain renaming: %d", #UpdateScene.RENAME_LIST)
                local rename = UpdateScene.RENAME_LIST[1]
                table.remove(UpdateScene.RENAME_LIST, 1)
                os.rename(rename.old, rename.new)
                UpdateScene.RENAMED_TOTAL_SIZE = UpdateScene.RENAMED_TOTAL_SIZE + 1
            else
                self:finishUpdate(true)
                break
            end
        end
    end
end

function UpdateScene:onEnter()
    assert(UpdateScene.NEED_UPDATE)

    if not checkDirOK(self.updatePath) then
        self:run()
        return
    end

    checkClientVersions()
    getClientVersionInfo()

    cc.ui.UILabel.new({
        text = z.ResourceManager:getInstance():getLocalizedString("current_version") .. UpdateScene.CLIENT_VERSION_STR,
        size = 20,
        align = cc.ui.TEXT_ALIGN_LEFT
    })
        :align(display.LEFT_CENTER, 10, 20)
        :addTo(self)

    self._progressLabel:setString(z.ResourceManager:getInstance():getLocalizedString("check_update"))
    self._progress:stopAllActions()
    self._progress:runAction(cca.sineInOut(cca.progressTo(1, 30)))

    self:addNodeEventListener(cc.NODE_ENTER_FRAME_EVENT, function(dt) self:update(dt) end)
    self:scheduleUpdate()

 --    self.curListFile = self.updatePath .. UpdateScene.FLIST_FILENAME
 --    -- printInfo("------------curListFile: %s", self.curListFile)
	-- self.fileList = nil
	-- if io.exists(self.curListFile) then
 --        -- printInfo("------------curListFile exist")
	-- 	self.fileList = dofile(self.curListFile)
	-- end
	-- if self.fileList == nil then
	-- 	self.fileList = {
	-- 		ver = "1.0.0",
	-- 		stage = {},
	-- 		remove = {},
	-- 	}
	-- end

    self.requestCount = 0
    self.dataRecv = nil
	self.requesting = UpdateScene.VERSION_NUM_FILENAME
    self.requestingType = UpdateScene.T_VERSION_NUM
    -- self.newListFile = self.curListFile .. UpdateScene.UPDATE_TEMP_POSTFIX
    -- printInfo("------------newListFile: %s", self.newListFile)
    -- printInfo("------------requesting: %s", self.requesting)
	self:requestFromServer(self.requesting, true)
end

function UpdateScene:onExit()
end

function UpdateScene:finishUpdate(run)
	printInfo("------------UpdateScene:finishUpdate")
    self:unscheduleUpdate()

    -- if not UpdateScene.SERVER_VERSION_STR then
    --     -- 无法连接服务器，请检查网络
    --     local alertView = AlertOK4U.new({
    --         desc = "无法连接服务器，请检查网络",
    --         ok = "退出",
    --         okCallback = function() cc.Director:getInstance():endToLua() end,
    --         })
    --         :pos(display.cx, display.cy)
    --         :addTo(self)
    --     alertView:actionEnter()
    --     return
    -- end

    -- local checkOK = true
    -- for k, v in pairs(UpdateScene.DOWNLOAD_LIST_SAVE) do
    --     if not checkFile(self.updatePath .. k, v.md5) then
    --         printInfo("------------Check Files Error: %s", k)
    --         checkOK = false
    --         break
    --     end
    -- end

    -- -- 下载失败
    -- if not checkOK then
    --     local alertView = AlertOK4U.new({
    --         desc = "更新失败，请退出重试",
    --         ok = "退出",
    --         okCallback = function() cc.Director:getInstance():endToLua() end,
    --         })
    --         :pos(display.cx, display.cy)
    --         :addTo(self)
    --     alertView:actionEnter()
    --     return
    -- end

    -- if checkOK then
        -- for k, v in pairs(UpdateScene.DOWNLOAD_LIST_SAVE) do
        --     if string.sub(k, string.len(k) - 4, string.len(k)) == ".zip" then
        --         cc.LuaLoadChunksFromZIP(self.updatePath .. k)
        --     end
        -- end
        -- for i,v in ipairs(self.fileList.remove) do
        --     removeFile(self.updatePath..v)
        -- end
    -- end

    -- if self.fileList and self.fileList.stage then
    --     local checkOK = true
    --     for i,v in ipairs(self.fileList.stage) do
    --         if not checkFile(self.updatePath..v.name, v.code) then
    --             printInfo("------------Check Files Error")
    --             checkOK = false
    --             break
    --         end
    --     end

    --     if checkOK then
    --         for i, v in ipairs(self.fileList.stage) do
    --             if v.act =="load" then
    --                 cc.LuaLoadChunksFromZIP(self.updatePath..v.name)
    --             end
    --         end
    --         for i,v in ipairs(self.fileList.remove) do
    --             removeFile(self.updatePath..v)
    --         end
    --     else
    --         removeFile(self.curListFile)
    --     end
    -- end

    if run then
        self:run()
    end
end

function UpdateScene:requestFromServer(filename, dump, waittime)
    local url = UpdateScene.SERVER_URL .. "/" .. filename .. UpdateScene.PARAM
    printInfo("------------URL: %s", url)
    self.requestCount = self.requestCount + 1
    local index = self.requestCount
    local request = network.createHTTPRequest(function(event)
            self:onResponse(event, index, dump)
        end, url, "GET")
    request:setTimeout(waittime or 60)
    request:start()
end

function UpdateScene:onResponse(event, index, dumpResponse)
    local request = event.request
    printInfo("------------REQUEST [%d] - event.name = %s", index, event.name)
    if event.name == "completed" then
        printInfo("------------REQUEST [%d] - code = %d", index, request:getResponseStatusCode())
        --printInfo("REQUEST %d - getResponseHeadersString() =\n%s", index, request:getResponseHeadersString())

        -- if UpdateScene.DOWNLOAD_TOTAL_SIZE > 0 then
        --     UpdateScene.DOWNLOAD_PROGRESS_SIZE = 0
        -- end

        if request:getResponseStatusCode() ~= 200 then
            local alertView = AlertOK4U.new({
                desc = z.ResourceManager:getInstance():getLocalizedString("download_failed"),
                ok = z.ResourceManager:getInstance():getLocalizedString("exit"),
                okCallback = function() cc.Director:getInstance():endToLua() end,
                })
                :pos(display.cx, display.cy)
                :addTo(self)
            alertView:actionEnter()
        	self:finishUpdate(false)
        else
            printInfo("------------REQUEST [%d] - data length = %d", index, request:getResponseDataLength())
            if dumpResponse then
                printInfo("------------REQUEST [%d] - response = %s", index, request:getResponseString())
            end
            self.dataRecv = request:getResponseData()
        end
    elseif event.name == "progress" then
        -- dump(event)
        -- printInfo("------------REQUEST progress [%f] [%f]", event.dltotal, event.total)
        if UpdateScene.DOWNLOAD_TOTAL_SIZE > 0 then
            UpdateScene.DOWNLOAD_PROGRESS_SIZE = event.dltotal
        end
    else
        printInfo("------------REQUEST [%d] - error code = %d, error msg = %s", index, request:getErrorCode(), request:getErrorMessage())
        local alertView = AlertOK4U.new({
            desc = z.ResourceManager:getInstance():getLocalizedString("download_failed"),
            ok = z.ResourceManager:getInstance():getLocalizedString("exit"),
            okCallback = function() cc.Director:getInstance():endToLua() end,
            })
            :pos(display.cx, display.cy)
            :addTo(self)
        alertView:actionEnter()
        self:finishUpdate(false)
    end

    -- printInfo("------------")
end

function UpdateScene:run()
    printInfo("------------UpdateScene:run")
    self:endProcess()
end

function UpdateScene:endProcess()
    self._loading = false

    self._progress:stopAllActions()
    self._progress:runAction(
        cc.Sequence:create(
            cc.EaseSineIn:create(cc.ProgressTo:create(0.3, 100)),
            cc.DelayTime:create(0.1),
            cc.CallFunc:create(function() 
                cc.LuaLoadChunksFromZIP(cc.FileUtils:getInstance():fullPathForFilename("game.zip"))
                require("AppMain") 
            end)
            )
        )
end

if not UpdateScene.NEED_UPDATE then
    cc.LuaLoadChunksFromZIP(cc.FileUtils:getInstance():fullPathForFilename("game.zip"))
    require("AppMain") 
else
    display.replaceScene(UpdateScene.new())
end
